////	$RCSfile: phonelist.h,v $
////	$Date: 1995/10/01 14:44:11 $
////.BlockStart
#ifndef PHONELIST_H_
#define PHONELIST_H_

#include <iostream>
#include <iomanip>

using namespace std;

#include "sllist.h"
////.BlockEnd

////.BlockStart
struct Record {
    char name[30+1];
    char number[12+1];
    void Print();
////.di dummy
    void Print() const {
	ios_base::fmtflags before;
	// This masks out the "justify" bits, then turns on "left".
	//
	before = cout.setf(ios::left,
			   ios::left | ios::right | ios::internal);
	cout << setw(35) << name << setw(15) << number << endl;
	cout.setf(before);
    }
////.di
};
////.BlockEnd

////.BlockStart
class PhoneListIter;		// forward declaration

class PhoneList {
    List *head;			// uses a linked list...
////.di dummy
    // This is getting ahead a bit, but these next two declare
    // the copy constructor and assignment operator as private.
    // That prevents the application from using "a = b;" in order
    // to copy a PhoneList object.
    //
    PhoneList(const PhoneList &);
    PhoneList & operator= (const PhoneList &);
////.di
////.BlockEnd
////.BlockStart
  public:
    PhoneList();
    ~PhoneList();		// Destructor must free memory
    void Add(Record *r);	// Adds to head of chain
    void Remove(Record *r);	// Removes from chain

    friend class PhoneListIter;
};
////.BlockEnd

////.BlockStart
class PhoneListIter {
    PhoneList &parent;	// reference to the parent object
    List *current;	// current element in list
////.di dummy
    // Notice that since we don't define the copy constructor
    // or overload the assignment operator, the application can
    // assign the value of one iterator to another and it'll work!
    // This is okay, because the parent (PhoneList) doesn't keep
    // a reference count of how many iterators there are...
    //
////.di
  public:
    PhoneListIter(PhoneList &p);
    Record *Current();
    Record *Next();
    void Reset();	// reset back to the beginning
};

#endif // PHONELIST_H_
////.BlockEnd
